From c974942d1fb70db83a14134d997ede3501e0b8fa Mon Sep 17 00:00:00 2001
From: David Lawrence Ramsey <pooka109@gmail.com>
Date: Sat, 24 Jun 2017 12:11:29 -0500
Subject: [PATCH] docs: consistently describe -U/-c and -r/-w overrides

Do this for both the manpages and both the nano and nanorc sections of
the info page.
---
 doc/nano.1    | 9 +++++----
 doc/nano.texi | 9 ++++++---
 doc/nanorc.5  | 9 ++++++---
 3 files changed, 17 insertions(+), 10 deletions(-)

diff --git a/doc/nano.1 b/doc/nano.1
index 41f0a33..b516eca 100644
--- a/doc/nano.1
+++ b/doc/nano.1
@@ -145,7 +145,8 @@ Set the size (width) of a tab to \fInumber\fP columns.  The value of
 .TP
 .BR \-U ", " \-\-quickblank
 Do quick status-bar blanking: status-bar messages will disappear after 1
-keystroke instead of 25.  Note that \fB\-c\fP overrides this.
+keystroke instead of 25.  Note that option \fB\-c\fP (\fB\-\-constantshow\fR)
+overrides this.
 .TP
 .BR \-V ", " \-\-version
 Show the current version number and exit.
@@ -165,7 +166,7 @@ defined in the \fInanorc\fP files.
 .TP
 .BR \-c ", " \-\-constantshow
 Constantly show the cursor position on the status bar.
-Note that this overrides \fB\-U\fP.
+Note that this overrides option \fB\-U\fP (\fB\-\-quickblank\fR).
 .TP
 .BR \-d ", " \-\-rebinddelete
 Interpret the Delete key differently so that both Backspace and Delete
@@ -221,7 +222,7 @@ Hard-wrap lines at column \fInumber\fP.  If this value is 0 or less, wrapping
 will occur at the width of the screen less \fInumber\fP columns, allowing
 the wrap point to vary along with the width of the screen if the screen
 is resized.  The default value is \-8.  This option conflicts with
-\fB\-w\fR -- the last one given takes effect.
+\fB\-w\fR (\fB\-\-nowrap\fR) -- the last one given takes effect.
 .TP
 .BR \-s\ \fIprogram\fR ", " \-\-speller= \fIprogram
 Use this alternative spell checker command.
@@ -239,7 +240,7 @@ Just view the file and disallow editing: read-only mode.
 .TP
 .BR \-w ", " \-\-nowrap
 Disable the hard-wrapping of long lines.  This option conflicts with
-\fB\-r\fR -- the last one given takes effect.
+\fB\-r\fR (\fB\-\-fill\fR) -- the last one given takes effect.
 .TP
 .BR \-x ", " \-\-nohelp
 Don't show the two help lines at the bottom of the screen.
diff --git a/doc/nano.texi b/doc/nano.texi
index a286fd1..e9758fe 100644
--- a/doc/nano.texi
+++ b/doc/nano.texi
@@ -690,6 +690,7 @@ Do case-sensitive searches by default.
 @item set constantshow
 Constantly display the cursor position on the status bar.
 (The old form of this option, @code{set const}, is deprecated.)
+Note that this overrides @option{quickblank}.
 
 @item set cut
 Use cut-to-end-of-line by default, instead of cutting the whole line.
@@ -697,7 +698,8 @@ Use cut-to-end-of-line by default, instead of cutting the whole line.
 @item set fill @var{number}
 Hard-wrap lines at column number @var{number}.  If @var{number} is 0 or less,
 the maximum line length will be the screen width less @var{number} columns.
-The default value is @t{-8}.
+The default value is @t{-8}.  This option conflicts with
+@option{nowrap}; the last one given takes effect.
 
 @item set functioncolor @var{fgcolor},@var{bgcolor}
 Specify the color combination to use for the function descriptions
@@ -752,7 +754,8 @@ the last one will be visible (when there are multiple ones).
 Don't add newlines to the ends of files.
 
 @item set nowrap
-Don't hard-wrap text at all.
+Don't hard-wrap text at all.  This option conflicts with
+@option{fill}; the last one given takes effect.
 
 @item set numbercolor @var{fgcolor},@var{bgcolor}
 Specify the color combination to use for line numbers.
@@ -781,7 +784,7 @@ The default value is @t{"!.?"}.
 
 @item set quickblank
 Do quick status-bar blanking: status-bar messages will disappear after 1
-keystroke instead of 25.
+keystroke instead of 25.  Note that @option{constantshow} overrides this.
 
 @item set quiet
 When set, @code{nano} will not report errors in the nanorc file nor ask them
diff --git a/doc/nanorc.5 b/doc/nanorc.5
index 1b1cc64..5b0c6b0 100644
--- a/doc/nanorc.5
+++ b/doc/nanorc.5
@@ -91,6 +91,7 @@ Do case-sensitive searches by default.
 .B set constantshow
 Constantly display the cursor position in the status bar.
 (The old form of this option, '\fBset const\fR', is deprecated.)
+This overrides the option \fBquickblank\fR.
 .TP
 .B set cut
 Use cut-to-end-of-line by default, instead of cutting the whole line.
@@ -98,7 +99,8 @@ Use cut-to-end-of-line by default, instead of cutting the whole line.
 .B set fill \fInumber\fR
 Hard-wrap lines at column number \fInumber\fR.  If \fInumber\fR is 0 or less,
 the maximum line length will be the screen width less \fInumber\fP columns.
-The default value is \fB\-8\fR.
+The default value is \fB\-8\fR.  This option conflicts with
+\fBnowrap\fR -- the last one given takes effect.
 .TP
 .B set functioncolor \fIfgcolor\fR,\fIbgcolor\fR
 Specify the color combination to use for the function descriptions
@@ -156,7 +158,8 @@ Don't pause between warnings at startup.  This means that only
 the last one will be visible (when there are multiple ones).
 .TP
 .B set nowrap
-Don't hard-wrap text at all.
+Don't hard-wrap text at all.  This option conflicts with
+\fBfill\fR -- the last one given takes effect.
 .TP
 .B set numbercolor \fIfgcolor\fR,\fIbgcolor\fR
 Specify the color combination to use for line numbers.
@@ -184,7 +187,7 @@ specfified closing punctuation, optionally followed by closing brackets
 .TP
 .B set quickblank
 Do quick status-bar blanking: status-bar messages will disappear after 1
-keystroke instead of 25.
+keystroke instead of 25.  The option \fBconstantshow\fR overrides this.
 .TP
 .B set quiet
 \fBnano\fP will not report errors in the \fInanorc\fP file nor ask them
-- 
2.9.0